Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -7273,10 +7318,10 @@
     push 00613h                               ; 68 13 06
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 10 c6
+    call 01922h                               ; e8 06 c6
     add sp, strict byte 00006h                ; 83 c4 06
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 c1 c5
+    call 018e1h                               ; e8 b7 c5
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     push ax                                   ; 50
@@ -7289,5 +7334,5 @@
     push 0063bh                               ; 68 3b 06
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 ea c5
+    call 01922h                               ; e8 e0 c5
     add sp, strict byte 0000ch                ; 83 c4 0c
     lea sp, [bp-002h]                         ; 8d 66 fe
@@ -7295,5 +7340,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-set_geom_lba_:                               ; 0xf532c LB 0x9e
+set_geom_lba_:                               ; 0xf534b LB 0x9e
     push si                                   ; 56
     push di                                   ; 57
@@ -7307,12 +7352,12 @@
     mov di, 000ffh                            ; bf ff 00
     xor bx, bx                                ; 31 db
-    jmp short 0534dh                          ; eb 05
+    jmp short 0536ch                          ; eb 05
     cmp bx, strict byte 00004h                ; 83 fb 04
-    jnl short 05363h                          ; 7d 16
+    jnl short 05382h                          ; 7d 16
     cmp dx, word [bp-002h]                    ; 3b 56 fe
-    jnbe short 05359h                         ; 77 07
-    jne short 0535ch                          ; 75 08
+    jnbe short 05378h                         ; 77 07
+    jne short 0537bh                          ; 75 08
     cmp ax, word [bp-004h]                    ; 3b 46 fc
-    jc short 0535ch                           ; 72 03
+    jc short 0537bh                           ; 72 03
     inc di                                    ; 47
     shr di, 1                                 ; d1 ef
@@ -7320,18 +7365,18 @@
     rcr ax, 1                                 ; d1 d8
     inc bx                                    ; 43
-    jmp short 05348h                          ; eb e5
+    jmp short 05367h                          ; eb e5
     mov ax, di                                ; 89 f8
     xor dx, dx                                ; 31 d2
     mov bx, strict word 0003fh                ; bb 3f 00
     xor cx, cx                                ; 31 c9
-    call 09219h                               ; e8 aa 3e
+    call 09439h                               ; e8 ab 40
     mov bx, ax                                ; 89 c3
     mov cx, dx                                ; 89 d1
     mov ax, word [bp-004h]                    ; 8b 46 fc
     mov dx, word [bp-002h]                    ; 8b 56 fe
-    call 091e0h                               ; e8 64 3e
+    call 09400h                               ; e8 65 40
     mov word [es:si+002h], ax                 ; 26 89 44 02
     cmp ax, 00400h                            ; 3d 00 04
-    jbe short 0538bh                          ; 76 06
+    jbe short 053aah                          ; 76 06
     mov word [es:si+002h], 00400h             ; 26 c7 44 02 00 04
     mov word [es:si], di                      ; 26 89 3c
@@ -7341,45 +7386,41 @@
     pop si                                    ; 5e
     retn                                      ; c3
+    jnc short 0540dh                          ; 73 54
+    cwd                                       ; 99
     push sp                                   ; 54
-    push sp                                   ; 54
-    jp short 053f0h                           ; 7a 54
-    cmpsw                                     ; a7
-    push sp                                   ; 54
-    cmpsw                                     ; a7
-    push sp                                   ; 54
-    cmpsw                                     ; a7
-    push sp                                   ; 54
-    jnle short 053fah                         ; 7f 56
-    lodsw                                     ; ad
+    db  0c6h, 054h, 0c6h, 054h
+    ; mov byte [si-03ah], 054h                  ; c6 54 c6 54
+    db  0c6h, 054h, 09eh, 056h
+    ; mov byte [si-062h], 056h                  ; c6 54 9e 56
+    int3                                      ; cc
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    cbw                                       ; 98
-    push si                                   ; 56
-    mov dl, byte [bx-053h]                    ; 8a 57 ad
+    mov BH, strict byte 056h                  ; b7 56
+    test ax, 0cc57h                           ; a9 57 cc
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    mov dl, byte [bx-076h]                    ; 8a 57 8a
+    test ax, 0a957h                           ; a9 57 a9
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    push CS                                   ; 0e
+    sub ax, 0a957h                            ; 2d 57 a9
     push di                                   ; 57
-    mov dl, byte [bx-053h]                    ; 8a 57 ad
+    int3                                      ; cc
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    mov dl, byte [bx+03eh]                    ; 8a 57 3e
+    test ax, 05d57h                           ; a9 57 5d
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-    lodsw                                     ; ad
+    int3                                      ; cc
     push di                                   ; 57
-_int13_harddisk:                             ; 0xf53ca LB 0x441
+_int13_harddisk:                             ; 0xf53e9 LB 0x441
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -7387,5 +7428,5 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 43 c2
+    call 0161ch                               ; e8 24 c2
     mov si, 00122h                            ; be 22 01
     mov word [bp-004h], ax                    ; 89 46 fc
@@ -7393,11 +7434,11 @@
     mov dx, 0008eh                            ; ba 8e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 24 c2
+    call 0160eh                               ; e8 05 c2
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     xor ah, ah                                ; 30 e4
     cmp ax, 00080h                            ; 3d 80 00
-    jc short 053f9h                           ; 72 05
+    jc short 05418h                           ; 72 05
     cmp ax, 00090h                            ; 3d 90 00
-    jc short 05417h                           ; 72 1e
+    jc short 05436h                           ; 72 1e
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     xor ah, ah                                ; 30 e4
@@ -7409,7 +7450,7 @@
     push 0066dh                               ; 68 6d 06
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 fc c4
+    call 01922h                               ; e8 f2 c4
     add sp, strict byte 0000ah                ; 83 c4 0a
-    jmp near 057c8h                           ; e9 b1 03
+    jmp near 057e7h                           ; e9 b1 03
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     xor ah, ah                                ; 30 e4
@@ -7420,5 +7461,5 @@
     mov byte [bp-002h], dl                    ; 88 56 fe
     cmp dl, 010h                              ; 80 fa 10
-    jc short 05440h                           ; 72 10
+    jc short 0545fh                           ; 72 10
     push ax                                   ; 50
     mov ax, word [bp+016h]                    ; 8b 46 16
@@ -7427,20 +7468,20 @@
     push 0065eh                               ; 68 5e 06
     push 00698h                               ; 68 98 06
-    jmp short 0540ch                          ; eb cc
+    jmp short 0542bh                          ; eb cc
     mov bx, word [bp+016h]                    ; 8b 5e 16
     shr bx, 008h                              ; c1 eb 08
     cmp bx, strict byte 00018h                ; 83 fb 18
-    jnbe near 057adh                          ; 0f 87 60 03
+    jnbe near 057cch                          ; 0f 87 60 03
     add bx, bx                                ; 01 db
-    jmp word [cs:bx+05398h]                   ; 2e ff a7 98 53
+    jmp word [cs:bx+053b7h]                   ; 2e ff a7 b7 53
     cmp byte [bp-002h], 008h                  ; 80 7e fe 08
-    jnc near 05463h                           ; 0f 83 07 00
+    jnc near 05482h                           ; 0f 83 07 00
     movzx ax, byte [bp-002h]                  ; 0f b6 46 fe
-    call 01c0ch                               ; e8 a9 c7
+    call 01c21h                               ; e8 9f c7
     mov byte [bp+017h], 000h                  ; c6 46 17 00
     xor bx, bx                                ; 31 db
     mov dx, strict word 00074h                ; ba 74 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 9c c1
+    call 0160eh                               ; e8 7d c1
     and byte [bp+01ch], 0feh                  ; 80 66 1c fe
     mov sp, bp                                ; 89 ec
@@ -7449,5 +7490,5 @@
     mov dx, strict word 00074h                ; ba 74 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 7d c1
+    call 01600h                               ; e8 5e c1
     mov cl, al                                ; 88 c1
     mov dx, word [bp+016h]                    ; 8b 56 16
@@ -7460,8 +7501,8 @@
     mov dx, strict word 00074h                ; ba 74 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 6e c1
+    call 0160eh                               ; e8 4f c1
     test cl, cl                               ; 84 c9
-    je short 05467h                           ; 74 c3
-    jmp near 057e4h                           ; e9 3d 03
+    je short 05486h                           ; 74 c3
+    jmp near 05803h                           ; e9 3d 03
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -7483,11 +7524,11 @@
     mov ax, word [bp-00ch]                    ; 8b 46 f4
     cmp ax, 00080h                            ; 3d 80 00
-    jnbe short 054e2h                         ; 77 04
+    jnbe short 05501h                         ; 77 04
     test ax, ax                               ; 85 c0
-    jne short 05505h                          ; 75 23
-    mov bx, 00da6h                            ; bb a6 0d
+    jne short 05524h                          ; 75 23
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 df c3
+    call 018e1h                               ; e8 d5 c3
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -7496,7 +7537,7 @@
     push 006cah                               ; 68 ca 06
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 0e c4
+    call 01922h                               ; e8 04 c4
     add sp, strict byte 00008h                ; 83 c4 08
-    jmp near 057c8h                           ; e9 c3 02
+    jmp near 057e7h                           ; e9 c3 02
     movzx ax, byte [bp-002h]                  ; 0f b6 46 fe
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -7509,14 +7550,14 @@
     mov word [bp-00ah], dx                    ; 89 56 f6
     cmp di, ax                                ; 39 c7
-    jnc short 05532h                          ; 73 0c
+    jnc short 05551h                          ; 73 0c
     cmp cx, word [bp-008h]                    ; 3b 4e f8
-    jbe short 05532h                          ; 76 07
+    jbe short 05551h                          ; 76 07
     mov ax, word [bp-006h]                    ; 8b 46 fa
     cmp ax, dx                                ; 39 d0
-    jbe short 05560h                          ; 76 2e
-    mov bx, 00da6h                            ; bb a6 0d
+    jbe short 0557fh                          ; 76 2e
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 8f c3
+    call 018e1h                               ; e8 85 c3
     push dword [bp-008h]                      ; 66 ff 76 f8
     push di                                   ; 57
@@ -7530,12 +7571,12 @@
     push 006f2h                               ; 68 f2 06
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 b3 c3
+    call 01922h                               ; e8 a9 c3
     add sp, strict byte 00010h                ; 83 c4 10
-    jmp near 057c8h                           ; e9 68 02
+    jmp near 057e7h                           ; e9 68 02
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
     cmp ax, strict word 00004h                ; 3d 04 00
-    jne short 0556eh                          ; 75 03
-    jmp near 05463h                           ; e9 f5 fe
+    jne short 0558dh                          ; 75 03
+    jmp near 05482h                           ; e9 f5 fe
     movzx bx, byte [bp-002h]                  ; 0f b6 5e fe
     imul bx, bx, strict byte 00018h           ; 6b db 18
@@ -7543,15 +7584,15 @@
     add bx, si                                ; 01 f3
     cmp cx, word [es:bx+02ch]                 ; 26 3b 4f 2c
-    jne short 0558fh                          ; 75 0f
+    jne short 055aeh                          ; 75 0f
     mov ax, word [es:bx+030h]                 ; 26 8b 47 30
     cmp ax, word [bp-00ah]                    ; 3b 46 f6
-    jne short 0558fh                          ; 75 06
+    jne short 055aeh                          ; 75 06
     cmp byte [bp-002h], 008h                  ; 80 7e fe 08
-    jc short 055bfh                           ; 72 30
+    jc short 055deh                           ; 72 30
     mov ax, di                                ; 89 f8
     xor dx, dx                                ; 31 d2
     mov bx, cx                                ; 89 cb
     xor cx, cx                                ; 31 c9
-    call 09219h                               ; e8 7f 3c
+    call 09439h                               ; e8 80 3e
     xor bx, bx                                ; 31 db
     add ax, word [bp-008h]                    ; 03 46 f8
@@ -7559,5 +7600,5 @@
     mov bx, word [bp-00ah]                    ; 8b 5e f6
     xor cx, cx                                ; 31 c9
-    call 09219h                               ; e8 70 3c
+    call 09439h                               ; e8 71 3e
     xor bx, bx                                ; 31 db
     add ax, word [bp-006h]                    ; 03 46 fa
@@ -7612,9 +7653,9 @@
     mov word [bp+016h], bx                    ; 89 5e 16
     test dl, dl                               ; 84 d2
-    je near 05463h                            ; 0f 84 13 fe
-    mov bx, 00da6h                            ; bb a6 0d
+    je near 05482h                            ; 0f 84 13 fe
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 71 c2
+    call 018e1h                               ; e8 67 c2
     movzx ax, dl                              ; 0f b6 c2
     push ax                                   ; 50
@@ -7625,19 +7666,19 @@
     push 00739h                               ; 68 39 07
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 9c c2
+    call 01922h                               ; e8 92 c2
     add sp, strict byte 0000ah                ; 83 c4 0a
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
     or ah, 00ch                               ; 80 cc 0c
-    jmp near 057d0h                           ; e9 51 01
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 057efh                           ; e9 51 01
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 42 c2
+    call 018e1h                               ; e8 38 c2
     push 0075ah                               ; 68 5a 07
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 7b c2
+    call 01922h                               ; e8 71 c2
     add sp, strict byte 00004h                ; 83 c4 04
-    jmp near 05463h                           ; e9 cb fd
+    jmp near 05482h                           ; e9 cb fd
     movzx ax, byte [bp-002h]                  ; 0f b6 46 fe
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -7682,5 +7723,5 @@
     or dx, ax                                 ; 09 c2
     mov word [bp+012h], dx                    ; 89 56 12
-    jmp near 05463h                           ; e9 55 fd
+    jmp near 05482h                           ; e9 55 fd
     movzx ax, byte [bp-002h]                  ; 0f b6 46 fe
     cwd                                       ; 99
@@ -7698,10 +7739,10 @@
     and AL, strict byte 0c0h                  ; 24 c0
     cmp AL, strict byte 040h                  ; 3c 40
-    jne short 05733h                          ; 75 03
-    jmp near 05463h                           ; e9 30 fd
+    jne short 05752h                          ; 75 03
+    jmp near 05482h                           ; e9 30 fd
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
     or ah, 0aah                               ; 80 cc aa
-    jmp near 057d0h                           ; e9 92 00
+    jmp near 057efh                           ; e9 92 00
     movzx ax, byte [bp-002h]                  ; 0f b6 46 fe
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -7717,8 +7758,8 @@
     mov bx, word [bp-008h]                    ; 8b 5e f8
     xor cx, cx                                ; 31 c9
-    call 09219h                               ; e8 b1 3a
+    call 09439h                               ; e8 b2 3c
     mov bx, word [bp-006h]                    ; 8b 5e fa
     xor cx, cx                                ; 31 c9
-    call 09219h                               ; e8 a9 3a
+    call 09439h                               ; e8 aa 3c
     mov word [bp-010h], ax                    ; 89 46 f0
     mov word [bp-00eh], dx                    ; 89 56 f2
@@ -7729,9 +7770,9 @@
     or ah, 003h                               ; 80 cc 03
     mov word [bp+016h], ax                    ; 89 46 16
-    jmp near 05467h                           ; e9 dd fc
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 05486h                           ; e9 dd fc
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 37 c1
+    call 018e1h                               ; e8 2d c1
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -7740,11 +7781,11 @@
     push 00774h                               ; 68 74 07
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 66 c1
+    call 01922h                               ; e8 5c c1
     add sp, strict byte 00008h                ; 83 c4 08
-    jmp near 05463h                           ; e9 b6 fc
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 05482h                           ; e9 b6 fc
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 14 c1
+    call 018e1h                               ; e8 0a c1
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -7752,5 +7793,5 @@
     push 0065eh                               ; 68 5e 06
     push 007a7h                               ; 68 a7 07
-    jmp near 054fah                           ; e9 32 fd
+    jmp near 05519h                           ; e9 32 fd
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -7762,28 +7803,24 @@
     mov dx, strict word 00074h                ; ba 74 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 2a be
+    call 0160eh                               ; e8 0b be
     or byte [bp+01ch], 001h                   ; 80 4e 1c 01
-    jmp near 05476h                           ; e9 8b fc
-    cmpsb                                     ; a6
+    jmp near 05495h                           ; e9 8b fc
+    lds bx, [bx+si-023h]                      ; c5 58 dd
     pop ax                                    ; 58
-    mov si, 0be58h                            ; be 58 be
+    fstp qword [bx+si-023h]                   ; dd 58 dd
     pop ax                                    ; 58
-    mov si, 06d58h                            ; be 58 6d
+    mov [si+020h], ds                         ; 8c 5c 20
+    pop dx                                    ; 5a
+    fstp qword [bx+si+026h]                   ; dd 58 26
+    pop dx                                    ; 5a
+    mov [si-025h], ds                         ; 8c 5c db
     pop sp                                    ; 5c
-    add word [bp+si-042h], bx                 ; 01 5a be
-    pop ax                                    ; 58
-    pop ES                                    ; 07
-    pop dx                                    ; 5a
-    insw                                      ; 6d
+    fistp dword [si-025h]                     ; db 5c db
     pop sp                                    ; 5c
-    mov sp, 0bc5ch                            ; bc 5c bc
+    fistp dword [si-05dh]                     ; db 5c a3
     pop sp                                    ; 5c
-    mov sp, 0bc5ch                            ; bc 5c bc
+    fistp dword [si-025h]                     ; db 5c db
     pop sp                                    ; 5c
-    test byte [si-044h], bl                   ; 84 5c bc
-    pop sp                                    ; 5c
-    db  0bch
-    pop sp                                    ; 5c
-_int13_harddisk_ext:                         ; 0xf580b LB 0x4cc
+_int13_harddisk_ext:                         ; 0xf582a LB 0x4cc
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -7791,9 +7828,9 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 02 be
+    call 0161ch                               ; e8 e3 bd
     mov word [bp-014h], ax                    ; 89 46 ec
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 f6 bd
+    call 0161ch                               ; e8 d7 bd
     mov si, 00122h                            ; be 22 01
     mov word [bp-026h], ax                    ; 89 46 da
@@ -7801,11 +7838,11 @@
     mov dx, 0008eh                            ; ba 8e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 d7 bd
+    call 0160eh                               ; e8 b8 bd
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     xor ah, ah                                ; 30 e4
     cmp ax, 00080h                            ; 3d 80 00
-    jc short 05846h                           ; 72 05
+    jc short 05865h                           ; 72 05
     cmp ax, 00090h                            ; 3d 90 00
-    jc short 05864h                           ; 72 1e
+    jc short 05883h                           ; 72 1e
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     xor ah, ah                                ; 30 e4
@@ -7817,7 +7854,7 @@
     push 0066dh                               ; 68 6d 06
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 af c0
+    call 01922h                               ; e8 a5 c0
     add sp, strict byte 0000ah                ; 83 c4 0a
-    jmp near 05c9ah                           ; e9 36 04
+    jmp near 05cb9h                           ; e9 36 04
     mov ax, word [bp+00eh]                    ; 8b 46 0e
     xor ah, ah                                ; 30 e4
@@ -7827,5 +7864,5 @@
     mov cl, byte [es:bx+0011fh]               ; 26 8a 8f 1f 01
     cmp cl, 010h                              ; 80 f9 10
-    jc short 0588ah                           ; 72 10
+    jc short 058a9h                           ; 72 10
     push ax                                   ; 50
     mov ax, word [bp+016h]                    ; 8b 46 16
@@ -7834,14 +7871,14 @@
     push 007d5h                               ; 68 d5 07
     push 00698h                               ; 68 98 06
-    jmp short 05859h                          ; eb cf
+    jmp short 05878h                          ; eb cf
     mov bx, word [bp+016h]                    ; 8b 5e 16
     shr bx, 008h                              ; c1 eb 08
     sub bx, strict byte 00041h                ; 83 eb 41
     cmp bx, strict byte 0000fh                ; 83 fb 0f
-    jnbe near 05cbch                          ; 0f 87 22 04
+    jnbe near 05cdbh                          ; 0f 87 22 04
     add bx, bx                                ; 01 db
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
-    jmp word [cs:bx+057ebh]                   ; 2e ff a7 eb 57
+    jmp word [cs:bx+0580ah]                   ; 2e ff a7 0a 58
     mov word [bp+010h], 0aa55h                ; c7 46 10 55 aa
     mov ax, word [bp+016h]                    ; 8b 46 16
@@ -7850,5 +7887,5 @@
     mov word [bp+016h], ax                    ; 89 46 16
     mov word [bp+014h], strict word 00007h    ; c7 46 14 07 00
-    jmp near 05c71h                           ; e9 b3 03
+    jmp near 05c90h                           ; e9 b3 03
     mov bx, word [bp+00ah]                    ; 8b 5e 0a
     mov es, [bp+004h]                         ; 8e 46 04
@@ -7865,5 +7902,5 @@
     mov ax, word [es:bx+00eh]                 ; 26 8b 47 0e
     or ax, word [bp-00ah]                     ; 0b 46 f6
-    je short 058ffh                           ; 74 11
+    je short 0591eh                           ; 74 11
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -7872,5 +7909,5 @@
     push 007e8h                               ; 68 e8 07
     push strict byte 00007h                   ; 6a 07
-    jmp short 05949h                          ; eb 4a
+    jmp short 05968h                          ; eb 4a
     mov es, [bp-010h]                         ; 8e 46 f0
     mov ax, word [es:di+008h]                 ; 26 8b 45 08
@@ -7884,13 +7921,13 @@
     mov ch, byte [es:bx+01eh]                 ; 26 8a 6f 1e
     cmp ax, word [es:bx+034h]                 ; 26 3b 47 34
-    jnbe short 0592fh                         ; 77 0b
-    jne short 05952h                          ; 75 2c
+    jnbe short 0594eh                         ; 77 0b
+    jne short 05971h                          ; 75 2c
     mov dx, word [bp-00ah]                    ; 8b 56 f6
     cmp dx, word [es:bx+032h]                 ; 26 3b 57 32
-    jc short 05952h                           ; 72 23
-    mov bx, 00da6h                            ; bb a6 0d
+    jc short 05971h                           ; 72 23
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 92 bf
+    call 018e1h                               ; e8 88 bf
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -7899,14 +7936,14 @@
     push 00811h                               ; 68 11 08
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 c1 bf
+    call 01922h                               ; e8 b7 bf
     add sp, strict byte 00008h                ; 83 c4 08
-    jmp near 05c9ah                           ; e9 48 03
+    jmp near 05cb9h                           ; e9 48 03
     mov dx, word [bp+016h]                    ; 8b 56 16
     shr dx, 008h                              ; c1 ea 08
     mov word [bp-00ch], dx                    ; 89 56 f4
     cmp dx, strict byte 00044h                ; 83 fa 44
-    je near 05c6dh                            ; 0f 84 0b 03
+    je near 05c8ch                            ; 0f 84 0b 03
     cmp dx, strict byte 00047h                ; 83 fa 47
-    je near 05c6dh                            ; 0f 84 04 03
+    je near 05c8ch                            ; 0f 84 04 03
     mov es, [bp-026h]                         ; 8e 46 da
     db  066h, 026h, 0c7h, 044h, 014h, 000h, 000h, 000h, 000h
